#include <WiFi.h>
#include <WiFiClient.h>
#include "PubSubClient.h"
#include "DHT11.h"
DHT11 dht11(2);
char ssid[] = "TA-Edu-AP02";
char password[] = "ta!13429";
int status = WL_IDLE_STATUS;
WiFiClient client;
IPAddress server(192, 168, 0, 2);
//byte server[] = { 192, 168, 0, 2 };
int port = 1883;
char topic[32];
char clientId[32];
byte byteMacAddr[6];
void msgReceived(char *topic, byte *payload, unsigned int uLen) {
  byte* p = (byte*)malloc(uLen);
  memcpy(p,payload,uLen);
  char message[256];
  int i = 0;
  for (i = 0; i < uLen; i++)
    message[i] = p[i];
  message[i] = '\0';
  Serial.println(message);
  free(p);
}
PubSubClient mqttClient(server, port, msgReceived, client);
void setup() {
  Serial.begin(9600);
  if (WiFi.status() == WL_NO_SHIELD) while(true);
  while(status != WL_CONNECTED) {
    status = WiFi.begin(ssid,password);
    delay(3000);
  }
  Serial.println("WiFi AP Connected!");
  /////////////////////////////////////////////////////////////////
  if (mqttClient.connect("arduinoClient")) {
    Serial.println("MQTT Server connected!");
    sprintf(topic,"arduino");
    mqttClient.publish(topic, "Hello,Arduino!");
    mqttClient.subscribe(topic);
  }
}
void loop() {
  mqttClient.loop();
  /////////////////////////////////////////////////
  int error;
    float temp,humidity;
    if ((error = dht11.read(humidity,temp)) == 0) {
      char message[64] = "";
      char pTempBuffer[50];
      dtostrf(temp , 5, 2, pTempBuffer);
      char pHumidityBuffer[50];
      dtostrf(humidity , 5, 2, pHumidityBuffer);
      sprintf(message, "{\"temp\":%s,\"humidity\":%s}", pTempBuffer,pHumidityBuffer);
      mqttClient.publish(topic, message);
    }
    delay(1000);
}
